#!/bin/bash
if : ; then
# File:         maths.sh
# Name:         Kevin Crotty
# Date:         31 Mar 2019
# Desc:         Maths in Bash
# Usage:        ./maths.sh

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White


: ' The two functions below colorize
    comments in green, and
    commands in red.'

function colorComment { echo -e "\n${BGreen}${1}${NC}"
}
function colorCommand { echo -e "${BRed}${1}${NC}"
}
fi
reset

colorComment "# Incrementing a variable"
colorCommand "var=3 && echo \$var"
echo -e "3"
colorCommand "var=\$((var+1)) && echo \$var"
echo -e "4"
colorCommand "((var=var+1)) && echo \$var"
echo -e "5"
colorCommand "((var+=1)) && echo \$var"
echo -e "6"
colorCommand "((var++)) && echo \$var"
echo -e "7"
colorCommand "let \"var=var+1\" && echo \$var"
echo -e "8"
colorCommand "let \"var+=1\" && echo \$var"
echo -e "9"

colorComment "# Bash Arithmetic"
echo -e "${BRed}var1=${BPurple}2${NC}"
echo -e "${BRed}var3=${BPurple}5${NC}"
echo -e "${BRed}echo \$var1 + \$var3 = \$((${BPurple}var1${BRed} + ${BPurple}var3${BRed}))${NC}"
echo -e "2 + 5 = 7"

echo && echo
