#!/bin/bash
  : '   # File  :         awk.sh
        # Name  :         Kevin Crotty
        # Date  :         Apr2020
        # Desc  :         
        # Usage :         source awk.sh'

# --- COLOR VARIABLES AND FUNCTIONS --- #
    export NC='\e[0m'               # Text Reset
    export BBlack='\e[1;30m'        # Black
    export BRed='\e[1;31m'          # Red
    export BGreen='\e[1;32m'        # Green
    export BYellow='\e[1;33m'       # Yellow
    export BBlue='\e[1;34m'         # Blue
    export BPurple='\e[1;35m'       # Purple
    export BCyan='\e[1;36m'         # Cyan
    export BWhite='\e[1;37m'        # White

    function comm { echo -e "${BGreen}${1}${NC}"
    }
    function cli { echo -e "${Red}# ${1}${NC}"
    }
    function label { echo -e "${BBlue}${1}${NC}"
    }
    function output { echo -e "${NC}${1}\n"
    }
    
    comm '# Usage: awk [options] file ...'
    comm '# options:'

    output \
"-f progfile   --file=progfile
-F fs         --field-separator=fs
-v var=val    --assign=var=val"

# Field Variables (NF = Number of Fields)
LINE='This is   a sentance         with 7 fields'
echo $LINE | awk '{print $2"--"$3,$NF}'

# First replace field 2 with a value
# Second print the whole line
echo "Hello Tom" | awk '{$2="Adam"; print $0}'

# awk variables
export VAR1
awk 'BEGIN {print ENVIRON["VAR1"]}' $FILENAME

# awk math
$ export A=50
$ export B=22
$ awk 'BEGIN { a = ENVIRON["A"]; b = ENVIRON["B"]; print "\n\tb divided by a equals", (b / a)"\n" }'    b divided by a equals 0.44

# system function in awk
awk 'BEGIN { ret = system("echo \"\x41\x41\x41\"BBB")}'

# --- AWK from a script --- #

cli 'cat > script.awk << EOF
#!/usr/bin/awk -f
BEGIN { name=ARGV[1]; FS=":" }
{print $1 " home at " $6 from name}
EOF'

  chmod +x script.awk
  ./script.awk /etc/passwd || awk -f script.awk /etc/passwd
