#!/bin/bash
if : ; then
# File:         find.sh
# Name:         Kevin Crotty
# Date:         25 Mar 2019
# Desc:         Demonstrate some 'find' examples
# Usage:        source find.sh

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White

function colorComment { echo -e "\n${BGreen}${1}${NC}"
}
function colorCommand { echo -e "${BRed}${1}${NC}"
}
fi

reset

echo -e "${BGreen}**OPTIONS (ie. -maxdepth 1) before TESTS (ie. -name or -type f) before ACTIONS (ie. -exec)"
echo -e "**For Example:\n"
echo -e "${BRed}find / -exec ls -l {} \; -name pass* -type f   ${BGreen}<--  Wrong"
echo -e "${BRed}find / -type f  -name pass* -exec ls -l {} \;   ${BGreen}<--  Correct${NC}"

colorCommand "find /etc -type f -name pass* 2>/dev/null | head"
echo -e "/etc/cron.daily/passwd"
echo -e "/etc/pam.d/passwd"
echo -e "/etc/passwd"
echo -e "/etc/passwd-"

colorCommand "find /etc -maxdepth 1 -type f -name pass* 2>/dev/null | head"
echo -e "/etc/passwd"
echo -e "/etc/passwd-"

colorCommand "find /repo/ -mtime 0 2>/dev/null | head"
echo -e "/repo/"
echo -e "/repo/public.eb"
echo -e "/repo/public.eb/.gitlab-ci.yml"
echo -e "/repo/public.eb/.git"
echo -e "/repo/public.eb/.git/hooks/post-commit"
echo -e "/repo/public.eb/.git/hooks/pre-push"

colorCommand "find \$PWD -user root -name  \"*.sh\"  2>/dev/null | head"
echo -e "/repo/linux-v1-class/scripts/4_RegexBasics/find.sh"
echo -e "/repo/linux-v1-class/scripts/4_RegexBasics/grep.sh"

colorCommand "find / -user root -perm /4000 -print 2>/dev/null | head"
echo -e "/snap/core/7270/bin/mount"
echo -e "/snap/core/7270/bin/ping"
echo -e "/snap/core/7270/bin/ping6"
echo -e "/snap/core/7270/bin/su"
echo -e "/snap/core/7270/bin/umount"
echo -e "/snap/core/7270/usr/bin/chfn\n\n"
