#!/bin/bash
if : ; then
# File:         invisibles.sh
# Name:         Kevin Crotty
# Date:         20 July 2019
# Desc:         Use 'strace' to show shell invisibles
# Usage:        ./invisibles.sh

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White

function colorComment { echo -e "\n${BGreen}${1}${NC}"
}
function colorCommand { echo -e "${BRed}${1}${NC}"
}
fi

reset

colorComment "# Shows newline character added automatically by the 'echo' command"
colorCommand "strace echo hello |& grep -E \"exec|write\""
echo -e "execve(\"/bin/echo\", [\"echo\", \"hello\"], 0x7ffdeaf7e908 /* 60 vars */) = 0"
echo  -e "write(1, ${BCyan}\"hello\x5Cn\"${NC}, 6hello)"
colorComment "# Be aware of invisible charecters and their effect on your commands and scripts"
colorCommand "strace echo -n hello |& grep -E \"exec|write\""
echo -e "execve(\"/bin/echo\", [\"echo\", \"-n\", \"hello\"], 0x7fff27379ff0 /* 60 vars */) = 0"
echo -e "write(1, ${BCyan}\"hello\"${NC}, 5hello)   "
