#!/bin/bash
if : ; then
# File:         orphan.sh
# Name:         Kevin Crotty
# Date:         29 Mar 2019
# Desc:         Demonstrate what an orphan process is
# Usage:        ./orphan.sh

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White

function colorComment { echo -e "\n${BGreen}${1}${NC}"
}
function colorCommand { echo -e "${BRed}${1}${NC}"
}
fi

colorComment "#  First Run of show-orphan.sh"
echo -e "${BGreen}#+ ${BCyan}Zero${NC}${BGreen} Orphans Shown"
echo -e "${BRed}root@debian# ./show-orphan.sh${NC}"
echo -e "echo \$\$ ${NC}"
echo -e "${BPurple}22439${NC}"
echo -e "\nsleep 5 & ${NC}"
echo -e "\nps --forest -el ${NC}"
echo -e "0 S root     22439  8834  0  80   0 -  4998 wait   21:00 pts/0    00:00:00              |   |   |           \_ /bin/bash ./show-orphan.sh"
echo -e "0 S root     22440 22439  0  80   0 -  3644 hrtime 21:00 pts/0    00:00:00              |   |   |               \_ sleep 5"

colorComment "#  Second Run of show-orphan.sh"
echo -e "${BGreen}#+ ${BCyan}One${NC}${BGreen} Orphan created"
echo -e "${BRed}root@debian# ./show-orphan.sh${NC}"
echo -e "echo \$\$ ${NC}"
echo -e "${BPurple}22445${NC}"
echo -e "\nsleep 5 & ${NC}"
echo -e "\nps --forest -el ${NC}"
echo -e "0 S root     22445  8834  0  80   0 -  4998 wait   21:00 pts/0    00:00:00              |   |   |           \_ /bin/bash ./show-orphan.sh"
echo -e "0 S root     22446 22445  0  80   0 -  3644 hrtime 21:00 pts/0    00:00:00              |   |   |               \_ sleep 5"
echo -e "0 S root     22440     ${BCyan}1${NC}  0  80   0 -  3644 hrtime 21:00 pts/0    00:00:00 sleep 5 ${BCyan}<-- First Orphan${NC}"

colorComment "#  Third Run of show-orphan.sh"
echo -e "${BGreen}#+ ${BCyan}Two${NC}${BGreen} Orphans created"
echo -e "${BRed}root@debian# ./show-orphan.sh${NC}"
echo -e "echo \$\$ ${NC}"
echo -e "${BPurple}22450${NC}"
echo -e "\nsleep 5 & ${NC}"
echo -e "\nps --forest -el ${NC}"
echo -e "0 S root     22450  8834  0  80   0 -  4998 wait   21:00 pts/0    00:00:00              |   |   |           \_ /bin/bash ./show-orphan.sh"
echo -e "0 S root     22451 22450  0  80   0 -  3644 hrtime 21:00 pts/0    00:00:00              |   |   |               \_ sleep 5"
echo -e "0 S root     22440     ${BCyan}1${NC}  0  80   0 -  3644 hrtime 21:00 pts/0    00:00:00 sleep 5 ${BCyan}<-- First Orphan${NC}"
echo -e "0 S root     22446     ${BCyan}1${NC}  0  80   0 -  3644 hrtime 21:00 pts/0    00:00:00 sleep 5 ${BCyan}<-- Second Orphan${NC}\n\n"
