#!/bin/bash
if : ; then
# File:         audit.sh
# Name:         Kevin Crotty
# Date:         28 Mar 2019
# Desc:         Demonstrate Auditctl Command Syntax
# Usage:        source audit.sh

# Set Colors for use in the script
export NC=' \e[0m'                # Text Reset
export BBlack=' \e[1;30m'         # Black
export BRed=' \e[1;31m'           # Red
export BGreen=' \e[1;32m'         # Green
export BYellow=' \e[1;33m'        # Yellow
export BBlue=' \e[1;34m'          # Blue
export BPurple=' \e[1;35m'        # Purple
export BCyan=' \e[1;36m'          # Cyan
export BWhite=' \e[1;37m'         # White

# Example demonstraion of color usage
# echo -e " \n${BGreen} \# \n "
# echo -e " \n\n${BRed} ${NC}"
fi

echo -e " \n${BGreen}# Generate Some Login Events ${NC}"
echo -e " sshpass -p 1235 ssh zeus@localhost ${BPurple} <-- Bad Login${NC}"
echo -e " sshpass -p 1234 ssh zeua@localhost${BPurple} <-- Bad Login${NC}"
echo -e " sshpass -p 1234 ssh zeus@localhost echo \" whoami=$(whoami)\"  ; sleep 2 ; exit ${BPurple} <-- Good Login${NC}"
echo -e " \n${BGreen}# Wipe rule config file for auditd ${NC}"
echo -e " ${BRed}cat /dev/null > /etc/audit/audit.rules ${NC}"
echo -e " ${BRed}auditctl -l ${NC} ${BPurple} <-- List any Filesystem or System Call rules ${NC}"
echo ' No rules'
echo -e " \n${BRed}aureport ${NC} ${BPurple} <-- Show Summary Report ${NC}"

echo ' Summary Report'
echo ' ======================'
echo ' Range of time in logs: 01/01/1970 00:00:00.000 - 01/01/1970 00:00:00.000'
echo ' Selected time for report: 01/01/1970 00:00:00 - 01/01/1970 00:00:00.000'
echo ' Number of logins: 1'
echo ' Number of failed logins: 2'
echo ' Number of authentications: 1'
echo ' Number of failed authentications: 2'
echo ' Number of users: 0'
echo -e "  ${BCyan}\n<--Output trimmed-->\n${NC}"

echo -e " \n${BRed}aureport -au${NC} ${BPurple} <-- Show authentication logs ${NC}"

echo ' Authentication Report'
echo ' ============================================'
echo '  date time acct host term exe success event'
echo ' ============================================'
echo ' 1. 03/29/2019 19:28:41 zeus 127.0.0.1 ssh /usr/sbin/sshd no 233>'
echo ' 2. 03/29/2019 19:28:41 zeus 127.0.0.1 ssh /usr/sbin/sshd no 235>'
echo ' 3. 03/29/2019 19:28:41 zeus 127.0.0.1 ssh /usr/sbin/sshd yes 237>'


echo -e "\n${BGreen}# Make Test Files ${NC}"
echo -e "${BRed}mkdir /AUDITD_DEMO/TEST && chmod 755 /AUDITD_DEMO/TEST"
echo -e "${BRed}touch /AUDITD_DEMO/TEST/test.txt && chmod 666 /AUDITD_DEMO/TEST/test.txt"
echo -e "\n${BGreen}# Creates Filesystem Rules ${NC}"
echo -e "${BRed}auditctl -w /AUDITD_DEMO/TEST/test.txt -p wa -k file_watch ${NC}"
echo -e "${BRed}auditctl -w /AUDITD_DEMO/TEST/ -k folder_watch ${NC}"

echo -e "\n${BRed}auditctl -l ${NC} ${BPurple} <-- Show the rules ${NC}"
echo '-w /AUDITD_DEMO/TEST/test.txt -p wa -k file_watch'
echo '-w /AUDITD_DEMO/TEST -p rwxa -k folder_watch'

echo -e "\n${BGreen}# Generate Events ${NC}"
echo -e "\n${BRed}cat /etc/passwd | grep root > /AUDITD_DEMO/TEST/test.txt ${NC}"
echo -e "${BRed}ls -l /AUDITD_DEMO/TEST ${NC}"
echo '.rw-rw-rw-  root  root  32 B  Thu Mar 28 01:12:18 2019  test.txt'

echo -e "\n${BGreen}# View Logs ${NC}"
echo -e "${BRed}ausearch -k file_watch | tail -n60 ${NC} ${BPurple} <--Query logs by key ${NC}"
echo '----'
echo 'time->Thu Mar 28 01:12:18 2019'
echo 'type=CONFIG_CHANGE msg=audit(1553735538.959:3515): auid=1001 ses=274 op=" add_rule"  key=" file_watch"  list=4 res=1'
echo '----'
echo 'time->Thu Mar 28 01:12:18 2019'
echo -e "type=PROCTITLE msg=audit(${BCyan}1553735538.979:3517${NC}): proctitle=\" -su\""
echo -e "type=PATH msg=audit(${BCyan}1553735538.979:3517${NC}): item=1 name=\" /AUDITD_DEMO/TEST/test.txt\"  inode=655667 nametype=NORMAL"
echo -e "type=PATH msg=audit(${BCyan}1553735538.979:3517${NC}): item=0 name=\" /AUDITD_DEMO/TEST/\"  inode=655595 nametype=PARENT"
echo -e "type=CWD msg=audit(${BCyan}1553735538.979:3517${NC}): cwd=\" /AUDITD_DEMO\""
echo -e "type=${BYellow}SYSCALL${NC} msg=audit(${BCyan}1553735538.979:3517${NC}): arch=c000003e syscall=2 success=yes exit=3 items=2 ppid=12699 pid=13804 auid=1001 \nuid=0 gid=0 euid=0 suid=0 tty=pts2 ses=274 ${BBlue}comm=\" bash\"  exe=\" /bin/bash\" ${NC} key=\" file_watch\" "
echo -e "\n${BRed}ausearch -k folder_watch | tail -n60 ${NC} ${BPurple} <--Query logs by key ${NC}"
echo '----'
echo 'time->Thu Mar 28 01:12:18 2019'
echo 'type=CONFIG_CHANGE msg=audit(1553735538.979:3516): auid=1001 ses=274 op=" add_rule"  key=" folder_watch"  list=4 res=1'
echo '----'
echo 'time->Thu Mar 28 01:12:18 2019'
echo 'type=PROCTITLE msg=audit(1553735538.983:3521): proctitle=6C7364002D6C002F7265706F2F6B6576696E2E6D2E63726F7474792F436C6173732F385F41756469744C6F6767696E672F4155444954445F44454D4F2F54455354'
echo 'type=PATH msg=audit(1553735538.983:3521): item=0 name=" /AUDITD_DEMO/TEST"  inode=655595 dev=fe:01 mode=040755 ouid=0 ogid=0 rdev=00:00 nametype=NORMAL'
echo 'type=CWD msg=audit(1553735538.983:3521): cwd=" /AUDITD_DEMO" '
echo -e "type=SYSCALL msg=audit(1553735538.983:3521): arch=c000003e ${BBlue}syscall=2${NC} success=yes exit=3 a0=55ced861fe00 a1=90800 a2=3b a3=1d170 items=1 ppid=12699 pid=13805 auid=1001 \nuid=0 gid=0 euid=0 suid=0 fsuid=0 egid=0 sgid=0 fsgid=0 tty=pts2 ses=274 ${BBlue} comm=\" ls\"  exe=\" /usr/bin/ls\" ${NC} key=\" folder_watch\" "
echo '----'
echo 'time->Thu Mar 28 01:12:18 2019'
echo 'type=PROCTITLE msg=audit(1553735538.983:3523): proctitle=6C7364002D6C002F7265706F2F6B6576696E2E6D2E63726F7474792F436C6173732F385F41756469744C6F6767696E672F4155444954445F44454D4F2F54455354'
echo 'type=PATH msg=audit(1553735538.983:3523): item=0 name=" /AUDITD_DEMO/TEST/test.txt"  inode=655667 dev=fe:01 mode=0100666 ouid=0 ogid=0 rdev=00:00 nametype=NORMAL'
echo 'type=CWD msg=audit(1553735538.983:3523): cwd=" /AUDITD_DEMO" '
echo -e "type=SYSCALL msg=audit(1553735538.983:3523): arch=c000003e ${BBlue}syscall=89${NC} success=no exit=-22 a0=55ced8628030 a1=55ced8628080 a2=100 a3=55ced7bde8b3 items=1 ppid=12699 pid=13805 auid=1001 \nuid=0 gid=0 euid=0 suid=0 fsuid=0 egid=0 sgid=0 fsgid=0 tty=pts2 ses=274 ${BBlue}comm=\" ls\"  exe=\" /usr/bin/ls\" ${NC} key=\" folder_watch\" "
echo -e "\n${BCyan} -- Output Trimmed --${NC}"

echo -e " \n${BRed}ausearch -k folder_watch | aureport -f -i | tail -n30 ${NC} ${BPurple} <--Pipe to aureport for formatting ${NC}\n"
echo ' File Report'
echo ' ==============================================='
echo '  date time file syscall success exe auid event'
echo ' ==============================================='
echo ' 1. 03/28/2019 01:12:18 /AUDITD_DEMO/TEST readlink no /usr/bin/ls crotty 3518'
echo ' 2. 03/28/2019 01:12:18 /AUDITD_DEMO/TEST readlink no /usr/bin/ls crotty 3519'
echo ' 3. 03/28/2019 01:12:18 /AUDITD_DEMO/TEST open yes /usr/bin/ls crotty 3520'
echo ' 4. 03/28/2019 01:12:18 /AUDITD_DEMO/TEST open yes /usr/bin/ls crotty 3521'
echo ' 5. 03/28/2019 01:12:18 /AUDITD_DEMO/TEST/test.txt readlink no /usr/bin/ls crotty 3522'
echo ' 6. 03/28/2019 01:12:18 /AUDITD_DEMO/TEST/test.txt readlink no /usr/bin/ls crotty 3523'  && echo && echo
